
varying vec4 v_fragmentColor; // vertex shader传入，setColor设置的颜色
varying vec2 v_texCoord; // 纹理坐标
uniform vec3 u_color ;    // 描边颜色
uniform float u_line_size ;    //描边偏移大小

//// 获得背面区域
float getBackArea()
{
    float u_line_size02 = u_line_size / 1.4142;

    vec4 color_up = texture2D(CC_Texture0, v_texCoord + vec2(0, u_line_size));
    vec4 color_down = texture2D(CC_Texture0, v_texCoord - vec2(0, u_line_size));
    vec4 color_left = texture2D(CC_Texture0, v_texCoord - vec2(u_line_size, 0));
    vec4 color_right = texture2D(CC_Texture0, v_texCoord + vec2(u_line_size, 0));
    vec4 color_up_left = texture2D(CC_Texture0, v_texCoord + vec2(u_line_size02, -u_line_size02));
    vec4 color_up_right = texture2D(CC_Texture0, v_texCoord + vec2(u_line_size02, u_line_size02));
    vec4 color_down_left = texture2D(CC_Texture0, v_texCoord + vec2(-u_line_size02, -u_line_size02));
    vec4 color_down_right = texture2D(CC_Texture0, v_texCoord + vec2(-u_line_size02, u_line_size02));
    float total = color_right.a + color_left.a + color_down.a + color_up.a +
    color_up_left.a + color_up_right.a + color_down_left.a + color_down_right.a;
    return clamp(total, 0.0, 1.0);
}

void main()
{

    // 获取正常的颜色值
    vec4 fragColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
    
    float isBack = getBackArea();
    
    if(isBack > 0.0)
    {
//        isBack = 1.0;
        if(fragColor.a < 0.01)
        {
            gl_FragColor = vec4(fragColor.rgb + (1.0 - fragColor.a) * u_color * isBack, 1.0);
        }
        else
        {
            gl_FragColor = fragColor;
        }
    }
    else
    {
        gl_FragColor = fragColor;
    }
    
}
